/* strefy.c */
#include "strefy.h"

int *strefy(int x, int y, int *wynik)
{
    int tmp, ile = 0;
    for (tmp = 0; tmp < MAX_STREF; tmp++)
	wynik[tmp] = -1;
    for (tmp = 0; tmp < MAX_STREF; tmp++)
	if (strefa[tmp].typ && strefa[tmp].sx <= x && x <= strefa[tmp].kx
	    && strefa[tmp].sy <= y && y <= strefa[tmp].ky)
	    wynik[ile++] = tmp;
    return wynik;
}

void wczytaj_strefy(struct _plik *in)
{
    int i, ile;
    struct strefa_IO tab;
    for (i = 0; i < MAXPOTW; i++)
	str_ist[i] = -1;
    i = 0;
    sread(in, &ile, sizeof(ile));
    while (i < ile) {
	sread(in, &tab, sizeof(struct strefa_IO));
	strefa[i].typ = tab.typ;
	strefa[i].podtyp = tab.podtyp;
	strefa[i].numer = -1;
	if (strefa[i].typ == SKLEP) {
	    sklep[ile_sklepow].numer_strefy = i;
	    sklep[ile_sklepow].ile_towarow = 0;
	    strefa[i].numer = ile_sklepow;
	    ile_sklepow++;
	}
	strefa[i].sx = tab.sx;
	strefa[i].kx = tab.kx;
	strefa[i].sy = tab.sy;
	strefa[i].ky = tab.ky;
	strefa[i].licznik = tab.licznik;
	strefa[i].Istota = NULL;
	str_ist[tab.Istota] = i;
	if (tab.pierwszy_raz) {
	    init_strefy(i);
	}
	i++;
    }

}

void init_strefy(int i)
{
    switch (strefa[i].typ) {
    case SKLEP:
	{
	    int x, y, ID;
	    for (x = strefa[i].sx + 1; x < strefa[i].kx; x++)
		for (y = strefa[i].sy + 1; y < strefa[i].ky; y++) {
		    switch (strefa[i].podtyp) {
		    case SPOZYWCZY:
			ID = szukaj_przedmiotu_z_klasy(KL_JEDZENIE,
						       Poziom.poziom + 5);
			break;
		    case Z_BRONIA:
			ID = szukaj_przedmiotu_z_klasy(KL_BR_JEDN |
						       KL_BR_DWUR,
						       Poziom.poziom + 5);
			break;
		    case Z_PANCERZAMI:
			ID = szukaj_przedmiotu_z_klasy(KL_NAKR_GLOWY |
						       KL_PANCERZ | KL_BUTY
						       | KL_TARCZE,
						       Poziom.poziom + 5);
		    }
		    dodaj_ladnie(x, y,
				 losowaoddo(przedmiotyID.ID[ID].ile_min,
					    przedmiotyID.ID[ID].ile_max),
				 ID, przedmiotyID.ID[ID].flagi,
				 -1, &Poziom.Przedmioty);
		    Poziom.Przedmioty.aktualny->strefa = i;
		    sklep[strefa[i].numer].towar[sklep[strefa[i].numer].
						 ile_towarow] =
			Poziom.Przedmioty.aktualny;
		    sklep[strefa[i].numer].ile_towarow++;
		}
	    break;
	}
    }
}
void zapisz_strefy(char *out, long int *ile)
{
    int i, tmp = MAX_STREF;
    struct strefa_IO tab;
    wsk_istota back = Poziom.Istoty.aktualny;

    /* Czyszczenie tablicy potwory<=>strefy */
    for (i = 0; i < MAXPOTW; i++)
	str_ist[i] = -1;

    /* Zapisanie tablicy potwory<=>strefy aktualnymi danymi */
    i = 0;
    for (Poziom.Istoty.aktualny = Poziom.Istoty.poczatek->nast->nast;
	 Poziom.Istoty.aktualny != Poziom.Istoty.koniec;
	 Poziom.Istoty.aktualny = Poziom.Istoty.aktualny->nast) {
	str_ist[numer_strefy_naleznej(Poziom.Istoty.aktualny)] = i;
	i++;
    }

    i = 0;
    *ile = 0;
    memcpy(&out[*ile], &tmp, sizeof(int));
    (*ile) += sizeof(int);
    while (i < MAX_STREF) {
	tab.typ = strefa[i].typ;
	tab.sx = strefa[i].sx;
	tab.kx = strefa[i].kx;
	tab.sy = strefa[i].sy;
	tab.ky = strefa[i].ky;
	tab.licznik = strefa[i].licznik;
	tab.Istota = str_ist[i];
	tab.podtyp = strefa[i].podtyp;
	tab.pierwszy_raz = 0;
	memcpy(&out[*ile], &tab, sizeof(struct strefa_IO));
	(*ile) += sizeof(struct strefa_IO);
	i++;
    }
    Poziom.Istoty.aktualny = back;
}

void wyczysc_strefy()
{
    int tmp;
    ile_sklepow = 0;
    for (tmp = 0; tmp < MAX_STREF; tmp++)
	strefa[tmp].typ = BRAK;
}

short int czy_jest_w_strefie(int typ, int x, int y)
{
    short int wynik = NIE_ZNALAZL;
    int buf[MAX_STREF], tmp;
    strefy(x, y, buf);
    for (tmp = 0; tmp < MAX_STREF && wynik == NIE_ZNALAZL; tmp++)
	if (strefa[buf[tmp]].typ == typ)
	    wynik = ZNALAZL;
    return wynik;
}

int numer_strefy(int typ, int x, int y)
{
    int wynik = -1;
    int buf[MAX_STREF], tmp;
    strefy(x, y, buf);
    for (tmp = 0; tmp < MAX_STREF && wynik == -1; tmp++)
	if (strefa[buf[tmp]].typ == typ)
	    wynik = buf[tmp];
    return wynik;
}

int numer_strefy_naleznej(wsk_istota do_kogo)
{
    int wynik = -1;
    int buf[MAX_STREF], tmp;
    strefy(do_kogo->x, do_kogo->y, buf);
    for (tmp = 0; tmp < MAX_STREF && wynik == -1; tmp++)
	if (strefa[buf[tmp]].Istota == do_kogo)
	    wynik = buf[tmp];
    return wynik;
}

int numer_w_sklepie(int numer_sklepu, wskaznik_przedmiot Towar)
{
    int i, wynik = -1;
    for (i = 0; i < sklep[numer_sklepu].ile_towarow && wynik == -1; i++) {
	if (sklep[numer_sklepu].towar[i] == Towar)
	    wynik = i;
    }
    return wynik;
}

struct delta szukaj_strefy(int numer_strefy, int x, int y)
{
    struct delta D;
    int i, j;
    D.x = -3;
    D.y = -3;
    for (i = -1; i < 2; i++)
	for (j = -1; j < 2; j++)
	    if (strefa[numer_strefy].sx < x + i
		&& strefa[numer_strefy].kx > x + i
		&& strefa[numer_strefy].sy < y + j
		&& strefa[numer_strefy].ky > y + j) {
		D.x = i;
		D.y = j;
	    }
    return D;
}
