/* convpot.c (konwerter potworwID) */
#include <stdio.h>
#include "fake.h"
#include "postac.h"

FILE *out, *lista, *potworyh;

int main(int argc, char *argv[])
{
    char tmp[1000];
    int i;
    if (!init_parser(argv[1])) {
	printf("Nie mog zainicjowa parsera!\n");
	exit(1);
    }
    out = fopen(argv[2], "wb");
    lista = fopen(argv[3], "wb");
    potworyh = fopen(argv[4], "wb");
    fprintf(potworyh,
	    "/* potwory.h */\n\n/* Plik generowany przez convpot zawierajcy stae odpowiadajce odpowiednim potworom */\n\n\n#ifndef POTWORY_H\n#define POTWORY_H\n\n");
    potworyID.ile = 0;
    while (!ustaw_kawalek("{", "}")) {
	potworyID.ID[potworyID.ile].typ = parser_znak("Znak:", 1, '@');
	potworyID.ID[potworyID.ile].kolor =
	    parser_liczba("Znak:", 2, 4, SP_KOLOR);
	strcpy(potworyID.ID[potworyID.ile].nazwa,
	       parser_string(tmp, "Mian:", 1, "Co si le sparsowao"));
	strcpy(potworyID.ID[potworyID.ile].nazwa_dop,
	       parser_string(tmp, "Bier:", 1,
			     potworyID.ID[potworyID.ile].nazwa));
	parser_string(tmp, "Const:", 1, "FOOBAR");
	if (strcmp(tmp, "FOOBAR"))
	    fprintf(potworyh, "#define PST_%s %d\n", tmp, potworyID.ile);
	for (i = 0; i < ILOSC_WSPOLCZYNNIKOW; i++) {
	    potworyID.ID[potworyID.ile].wspolcz_min[i] =
		parser_liczba("Wsp:", 2 * i + 1, 10, SP_LICZBA);
	    potworyID.ID[potworyID.ile].wspolcz_max[i] =
		parser_liczba("Wsp:", 2 * i + 2, 10, SP_LICZBA);
	}
	potworyID.ID[potworyID.ile].zasieg_widzenia =
	    parser_liczba("Zas:", 1, 5, SP_LICZBA);
	potworyID.ID[potworyID.ile].flagi =
	    parser_liczba("Fl:", 1, 0, SP_FL_POST);
	potworyID.ID[potworyID.ile].energia_max =
	    parser_liczba("En_max:", 1, 500000, SP_LICZBA);
	potworyID.ID[potworyID.ile].energia_start =
	    parser_liczba("En_st:", 1,
			  potworyID.ID[potworyID.ile].energia_max *
			  SREDNIO_NAJEDZONY / 100, SP_LICZBA);
#ifdef DEBUG
	if (potworyID.ID[potworyID.ile].energia_start < 10)
            fprintf(stderr, "Kto ma mao energii startowej: %s\n",potworyID.ID[potworyID.ile].nazwa);
#endif
	potworyID.ID[potworyID.ile].zloto_min =
	    parser_liczba("Zloto:", 1, 0, SP_LICZBA);
	potworyID.ID[potworyID.ile].zloto_max =
	    parser_liczba("Zloto:", 2,
			  potworyID.ID[potworyID.ile].zloto_min,
			  SP_LICZBA);
	potworyID.ID[potworyID.ile].hp_min =
	    parser_liczba("Hp_min:", 1, 10, SP_LICZBA);
	potworyID.ID[potworyID.ile].hp_max =
	    parser_liczba("Hp_max:", 1, 20, SP_LICZBA);
	potworyID.ID[potworyID.ile].hp_tur_min =
	    parser_liczba("Hp_tur_min:", 1, 50, SP_LICZBA);
	potworyID.ID[potworyID.ile].hp_tur_max =
	    parser_liczba("Hp_tur_max:", 1, 60, SP_LICZBA);
	potworyID.ID[potworyID.ile].pp_min =
	    parser_liczba("Pp_min:", 1, 0, SP_LICZBA);
	potworyID.ID[potworyID.ile].pp_max =
	    parser_liczba("Pp_max:", 1, 0, SP_LICZBA);
	potworyID.ID[potworyID.ile].pp_tur_min =
	    parser_liczba("Pp_tur_min:", 1, 1, SP_LICZBA);
	potworyID.ID[potworyID.ile].pp_tur_max =
	    parser_liczba("Pp_tur_max:", 1, 1, SP_LICZBA);
	potworyID.ID[potworyID.ile].psych_min =
	    parser_liczba("Psych_min:", 1, 10, SP_LICZBA);
	potworyID.ID[potworyID.ile].psych_max =
	    parser_liczba("Psych_max:", 1, 20, SP_LICZBA);
	potworyID.ID[potworyID.ile].psych_tur_min =
	    parser_liczba("Psych_tur_min:", 1, 50, SP_LICZBA);
	potworyID.ID[potworyID.ile].psych_tur_max =
	    parser_liczba("Psych_tur_max:", 1, 60, SP_LICZBA);
	potworyID.ID[potworyID.ile].przyt_min =
	    parser_liczba("Przyt_min:", 1, 10, SP_LICZBA);
	potworyID.ID[potworyID.ile].przyt_max =
	    parser_liczba("Przyt_max:", 1, 20, SP_LICZBA);
	potworyID.ID[potworyID.ile].przyt_tur_min =
	    parser_liczba("Przyt_tur_min:", 1, 50, SP_LICZBA);
	potworyID.ID[potworyID.ile].przyt_tur_max =
	    parser_liczba("Przyt_tur_max:", 1, 60, SP_LICZBA);
	potworyID.ID[potworyID.ile].szybkosc_min =
	    parser_liczba("Szyb_min:", 1, 95, SP_LICZBA);
	potworyID.ID[potworyID.ile].szybkosc_max =
	    parser_liczba("Szyb_max:", 1, 105, SP_LICZBA);
	potworyID.ID[potworyID.ile].pancerz_min =
	    parser_liczba("Pnc_min:", 1, 0, SP_LICZBA);
	potworyID.ID[potworyID.ile].pancerz_max =
	    parser_liczba("Pnc_max:", 1, 0, SP_LICZBA);
	potworyID.ID[potworyID.ile].nr_schematu_ekwipunku =
	    parser_liczba("Sch_ekw:", 1, 2, SP_LICZBA);
	potworyID.ID[potworyID.ile].nr_schematu_anatomii =
	    parser_liczba("Sch_anat:", 1, 0, SP_LICZBA);
	potworyID.ID[potworyID.ile].rasa =
	    parser_liczba("Rasa:", 1, 0, SP_RASA);
	potworyID.ID[potworyID.ile].klasa =
	    parser_liczba("Klasa:", 1, -1, SP_KLASA);
	potworyID.ID[potworyID.ile].plec =
	    parser_liczba("Plec:", 1, 3, SP_PLEC);
	potworyID.ID[potworyID.ile].exp =
	    parser_liczba("Exp:", 1, 10, SP_LICZBA);
	potworyID.ID[potworyID.ile].align =
	    parser_liczba("A:", 1, 0, SP_LICZBA);
	potworyID.ID[potworyID.ile].poziom =
	    parser_liczba("Poz:", 1, 1, SP_LICZBA);
	potworyID.ID[potworyID.ile].czestosc =
	    parser_liczba("Cz:", 1, 50, SP_LICZBA);
	potworyID.ID[potworyID.ile].przedmiot =
	    parser_liczba("ID:", 1, -1, SP_PRZEDM);
	strcpy(potworyID.ID[potworyID.ile].opis,
	       parser_string(tmp, "Opis:", 1, "Nie podano opisu"));
	fprintf(lista, "%d - %s\n", potworyID.ile,
		potworyID.ID[potworyID.ile].nazwa);
	potworyID.ile++;
    }
    zapisz_tablice_potw_ID(out, &potworyID);
    fclose(out);
    fclose(lista);
    fprintf(potworyh, "\n#endif\n");
    fclose(potworyh);
    return 0;
}
