#ifndef ekran_h
#define ekran_h

#include "config.h"

#ifdef _DJGPP
#include <curses.h>
#define WA_DIM A_DIM
#define WA_BOLD A_BOLD
#define WA_BLINK A_BLINK
#define WA_NORMAL A_NORMAL
#else
#include <ncurses.h>
#endif

#include <limits.h>

#include <string.h>
#include "ekran_dod.h"
#include "ekran_dod2.h"
#include "ekran_dod3.h"
#include "ekran_loc.h"
#include "structpoziom.h"
#include "postac.h"
#include "io.h"
#include "keymap.h"
#include "wspolczynniki.h"
#include "structpotwor.h"

struct bufor {
    int tab[12500];		/* Pocztki kolejnych linijek (?) */
    int z, zost;		/* Co jest co? - Andrzej */
    int kolor[12500];		/* Kolory jakimi _zaczynaj_ si poszczeglne linijki */
};

char gora[1000], bufor[50000];
char gora_stara[10000], _gora[1000];	/* Czym to si rni tak naprawd? */
char kom[20];
int ile_razy_powtorzony;
int maxx, maxy;
int poz_maxx, poz_maxy;


int refresh_opisu;
int ma_kolory;			/* 1, jeli na terminalu s kolory */
void init();

void init_kol();

/* Ustawia okienko, przy czym x i y to wsprzdne rodka */
void ustaw_okienko(struct poziom *Poziom, int x, int y);

void rysuj_przedmioty(struct poziom *Poziom,
		      struct przedmioty *Przedmioty);

/* Umoliwia wybranie przedmiotu z listy  (Zwraca 0, jeli si nie uda)*/
short int wybierz_przedmiot(struct przedmioty *Przedm,
			    short int czy_pytac_o_skrot, int flagi,
			    long int klasy);

void zmien_kolor(int kolor, WINDOW * okno);

void przesun_kursor(int x, int y);

void podziel_bufor_na_linijki(struct bufor *b, char *bufor);

char *pobierz_ciag();

int pobierz_liczbe();

void wyswietl_tekst(char *tekst);

void komunikat(char *kom);

void wypisz_klawisze();
int zapytaj_o_zapis();
#endif
