
/* przedmioty.c */

#include "przedmioty.h"

struct przedmiot Przedmiot;

/* Szuka pierwszego przedmiotu na polu(x,y) */
short int szukaj_przedmiotu(int x, int y, struct przedmioty *Przedmioty)
{
    short int wynik = NIE_ZNALAZL;
    if (!Przedmioty->ile) {
	return wynik;
    }
    for (Przedmioty->aktualny = Przedmioty->poczatek->nast;
	 (Przedmioty->aktualny != Przedmioty->koniec)
	 && (wynik != ZNALAZL);
	 Przedmioty->aktualny = Przedmioty->aktualny->nast) {
	if ((Przedmioty->aktualny->x == x)
	    && (Przedmioty->aktualny->y == y))
	    wynik = ZNALAZL;
    }
    if (wynik == ZNALAZL)
	Przedmioty->aktualny = Przedmioty->aktualny->poprz;
    return wynik;

}

char *nazwa_materialu(int ktorego, char *buf, int rodzaj, int liczba,
		      int przypadek)
{
    switch (liczba) {
    case LCZ_POJEDYNCZA:
	{
	    switch (rodzaj) {
	    case RDZ_MESKI:
		switch (ktorego) {
		case MAT_PLOTNO:
		    strcpy(buf, _("pcienny"));
		    break;
		case MAT_SKORA:
		    strcpy(buf, _("skrzany"));
		    break;
		case MAT_UTWARDZONA_SKORA:
		    strcpy(buf, _("utwardzony skrzany"));
		    break;
		case MAT_DREWNO:
		    strcpy(buf, _("drewniany"));
		    break;
		case MAT_JEDWAB:
		    strcpy(buf, _("jedwabny"));
		    break;
		case MAT_SZKLO:
		    strcpy(buf, _("szklany"));
		    break;
		case MAT_KRYSZTAL:
		    strcpy(buf, _("krysztaowy"));
		    break;
		case MAT_URAN:
		    strcpy(buf, _("uranowy"));
		    break;
		case MAT_PAPIER:
		    strcpy(buf, _("papierowy"));
		    break;
		case MAT_BRAZ:
		    strcpy(buf, _("brzowy"));
		    break;
		case MAT_ZELAZO:
		    strcpy(buf, _("elazny"));
		    break;
		case MAT_STAL:
		    strcpy(buf, _("stalowy"));
		    break;
		case MAT_SREBRO:
		    strcpy(buf, _("srebrny"));
		    break;
		case MAT_ZLOTO:
		    strcpy(buf, _("zoty"));
		    break;
		case MAT_CYNA:
		    strcpy(buf, _("cynowy"));
		    break;
		case MAT_OLOW:
		    strcpy(buf, _("oowiany"));
		    break;
		case MAT_ZELIWO:
		    strcpy(buf, _("eliwny"));
		    break;
		case MAT_MIEDZ:
		    strcpy(buf, _("miedziany"));
		    break;
		case MAT_CYNK:
		    strcpy(buf, _("cynkowy"));
		    break;
		case MAT_MOSIADZ:
		    strcpy(buf, _("mosiny"));
		    break;
		case MAT_TYTAN:
		    strcpy(buf, _("tytanowy"));
		    break;
		case MAT_IRYD:
		    strcpy(buf, _("irydowy"));
		    break;
		case MAT_KEVLAR:
		    strcpy(buf, _("kevlarowy"));
		    break;
		case MAT_KRYPTONIT:
		    strcpy(buf, _("kryptonitowy"));
		    break;
		case MAT_ADAMANIT:
		    strcpy(buf, _("adamanitowy"));
		    break;
		case MAT_JEDZENIE:
		    strcpy(buf, _(""));
		    break;
		default:
		    strcpy(buf, _("wykonany z nieznanego materiau"));
		    break;
		}
		break;
	    case RDZ_ZENSKI:
		switch (przypadek) {
		case PRZYP_MIANOWNIK:
		    switch (ktorego) {
		    case MAT_PLOTNO:
			strcpy(buf, _("pcienna"));
			break;
		    case MAT_SKORA:
			strcpy(buf, _("skrzana"));
			break;
		    case MAT_UTWARDZONA_SKORA:
			strcpy(buf, _("utwardzona skrzana"));
			break;
		    case MAT_DREWNO:
			strcpy(buf, _("drewniana"));
			break;
		    case MAT_JEDWAB:
			strcpy(buf, _("jedwabna"));
			break;
		    case MAT_SZKLO:
			strcpy(buf, _("szklana"));
			break;
		    case MAT_KRYSZTAL:
			strcpy(buf, _("krysztaowa"));
			break;
		    case MAT_URAN:
			strcpy(buf, _("uranowa"));
			break;
		    case MAT_PAPIER:
			strcpy(buf, _("papierowa"));
			break;
		    case MAT_BRAZ:
			strcpy(buf, _("brzowa"));
			break;
		    case MAT_ZELAZO:
			strcpy(buf, _("elazna"));
			break;
		    case MAT_STAL:
			strcpy(buf, _("stalowa"));
			break;
		    case MAT_SREBRO:
			strcpy(buf, _("srebrna"));
			break;
		    case MAT_ZLOTO:
			strcpy(buf, _("zota"));
			break;
		    case MAT_CYNA:
			strcpy(buf, _("cynowa"));
			break;
		    case MAT_OLOW:
			strcpy(buf, _("oowiana"));
			break;
		    case MAT_ZELIWO:
			strcpy(buf, _("eliwna"));
			break;
		    case MAT_MIEDZ:
			strcpy(buf, _("miedziana"));
			break;
		    case MAT_CYNK:
			strcpy(buf, _("cynkowa"));
			break;
		    case MAT_MOSIADZ:
			strcpy(buf, _("mosina"));
			break;
		    case MAT_TYTAN:
			strcpy(buf, _("tytanowa"));
			break;
		    case MAT_IRYD:
			strcpy(buf, _("irydowa"));
			break;
		    case MAT_KEVLAR:
			strcpy(buf, _("kevlarowa"));
			break;
		    case MAT_KRYPTONIT:
			strcpy(buf, _("kryptonitowa"));
			break;
		    case MAT_ADAMANIT:
			strcpy(buf, _("adamanitowa"));
			break;
		    case MAT_JEDZENIE:
			strcpy(buf, _(""));
			break;
		    default:
			strcpy(buf, _("wykonana z nieznanego materiau"));
			break;
		    }
		    break;
		case PRZYP_BIERNIK:
		    switch (ktorego) {
		    case MAT_PLOTNO:
			strcpy(buf, _("pcienn"));
			break;
		    case MAT_SKORA:
			strcpy(buf, _("skrzan"));
			break;
		    case MAT_UTWARDZONA_SKORA:
			strcpy(buf, _("utwardzon skrzan"));
			break;
		    case MAT_DREWNO:
			strcpy(buf, _("drewnian"));
			break;
		    case MAT_JEDWAB:
			strcpy(buf, _("jedwabn"));
			break;
		    case MAT_SZKLO:
			strcpy(buf, _("szklan"));
			break;
		    case MAT_KRYSZTAL:
			strcpy(buf, _("krysztaow"));
			break;
		    case MAT_URAN:
			strcpy(buf, _("uranow"));
			break;
		    case MAT_PAPIER:
			strcpy(buf, _("papierow"));
			break;
		    case MAT_BRAZ:
			strcpy(buf, _("brzow"));
			break;
		    case MAT_ZELAZO:
			strcpy(buf, _("elazn"));
			break;
		    case MAT_STAL:
			strcpy(buf, _("stalow"));
			break;
		    case MAT_SREBRO:
			strcpy(buf, _("srebrn"));
			break;
		    case MAT_ZLOTO:
			strcpy(buf, _("zot"));
			break;
		    case MAT_CYNA:
			strcpy(buf, _("cynow"));
			break;
		    case MAT_OLOW:
			strcpy(buf, _("oowian"));
			break;
		    case MAT_ZELIWO:
			strcpy(buf, _("eliwn"));
			break;
		    case MAT_MIEDZ:
			strcpy(buf, _("miedzian"));
			break;
		    case MAT_CYNK:
			strcpy(buf, _("cynkow"));
			break;
		    case MAT_MOSIADZ:
			strcpy(buf, _("mosin"));
			break;
		    case MAT_TYTAN:
			strcpy(buf, _("tytanow"));
			break;
		    case MAT_IRYD:
			strcpy(buf, _("irydow"));
			break;
		    case MAT_KEVLAR:
			strcpy(buf, _("kevlarow"));
			break;
		    case MAT_KRYPTONIT:
			strcpy(buf, _("kryptonitow"));
			break;
		    case MAT_ADAMANIT:
			strcpy(buf, _("adamanitow"));
			break;
		    case MAT_JEDZENIE:
			strcpy(buf, _(""));
			break;
		    default:
			strcpy(buf, _("wykonan z nieznanego materiau"));
			break;
		    }
		    break;
		}
		break;
	    case RDZ_NIJAKI:
		switch (ktorego) {
		case MAT_PLOTNO:
		    strcpy(buf, _("pcienne"));
		    break;
		case MAT_SKORA:
		    strcpy(buf, _("skrzane"));
		    break;
		case MAT_UTWARDZONA_SKORA:
		    strcpy(buf, _("utwardzone skrzane"));
		    break;
		case MAT_DREWNO:
		    strcpy(buf, _("drewniane"));
		    break;
		case MAT_JEDWAB:
		    strcpy(buf, _("jedwabne"));
		    break;
		case MAT_SZKLO:
		    strcpy(buf, _("szklane"));
		    break;
		case MAT_KRYSZTAL:
		    strcpy(buf, _("krysztaowe"));
		    break;
		case MAT_URAN:
		    strcpy(buf, _("uranowe"));
		    break;
		case MAT_PAPIER:
		    strcpy(buf, _("papierowe"));
		    break;
		case MAT_BRAZ:
		    strcpy(buf, _("brzowe"));
		    break;
		case MAT_ZELAZO:
		    strcpy(buf, _("elazne"));
		    break;
		case MAT_STAL:
		    strcpy(buf, _("stalowe"));
		    break;
		case MAT_SREBRO:
		    strcpy(buf, _("srebrne"));
		    break;
		case MAT_ZLOTO:
		    strcpy(buf, _("zote"));
		    break;
		case MAT_CYNA:
		    strcpy(buf, _("cynowe"));
		    break;
		case MAT_OLOW:
		    strcpy(buf, _("oowiane"));
		    break;
		case MAT_ZELIWO:
		    strcpy(buf, _("eliwne"));
		    break;
		case MAT_MIEDZ:
		    strcpy(buf, _("miedziane"));
		    break;
		case MAT_CYNK:
		    strcpy(buf, _("cynkowe"));
		    break;
		case MAT_MOSIADZ:
		    strcpy(buf, _("mosine"));
		    break;
		case MAT_TYTAN:
		    strcpy(buf, _("tytanowe"));
		    break;
		case MAT_IRYD:
		    strcpy(buf, _("irydowe"));
		    break;
		case MAT_KEVLAR:
		    strcpy(buf, _("kevlarowe"));
		    break;
		case MAT_KRYPTONIT:
		    strcpy(buf, _("kryptonitowe"));
		    break;
		case MAT_ADAMANIT:
		    strcpy(buf, _("adamanitowe"));
		    break;
		case MAT_JEDZENIE:
		    strcpy(buf, _(""));
		    break;
		default:
		    strcpy(buf, _("wykonane z nieznanego materiau"));
		    break;
		}
		break;
	    }
	}
	break;
    case LCZ_MNOGA:
	switch (ktorego) {
	case MAT_PLOTNO:
	    strcpy(buf, _("pcienne"));
	    break;
	case MAT_SKORA:
	    strcpy(buf, _("skrzane"));
	    break;
	case MAT_UTWARDZONA_SKORA:
	    strcpy(buf, _("utwardzone skrzane"));
	    break;
	case MAT_DREWNO:
	    strcpy(buf, _("drewniane"));
	    break;
	case MAT_JEDWAB:
	    strcpy(buf, _("jedwabne"));
	    break;
	case MAT_SZKLO:
	    strcpy(buf, _("szklane"));
	    break;
	case MAT_KRYSZTAL:
	    strcpy(buf, _("krysztaowe"));
	    break;
	case MAT_URAN:
	    strcpy(buf, _("uranowe"));
	    break;
	case MAT_PAPIER:
	    strcpy(buf, _("papierowe"));
	    break;
	case MAT_BRAZ:
	    strcpy(buf, _("brzowe"));
	    break;
	case MAT_ZELAZO:
	    strcpy(buf, _("elazne"));
	    break;
	case MAT_STAL:
	    strcpy(buf, _("stalowe"));
	    break;
	case MAT_SREBRO:
	    strcpy(buf, _("srebrne"));
	    break;
	case MAT_ZLOTO:
	    strcpy(buf, _("zote"));
	    break;
	case MAT_CYNA:
	    strcpy(buf, _("cynowe"));
	    break;
	case MAT_OLOW:
	    strcpy(buf, _("oowiane"));
	    break;
	case MAT_ZELIWO:
	    strcpy(buf, _("eliwne"));
	    break;
	case MAT_MIEDZ:
	    strcpy(buf, _("miedziane"));
	    break;
	case MAT_CYNK:
	    strcpy(buf, _("cynkowe"));
	    break;
	case MAT_MOSIADZ:
	    strcpy(buf, _("mosine"));
	    break;
	case MAT_TYTAN:
	    strcpy(buf, _("tytanowe"));
	    break;
	case MAT_IRYD:
	    strcpy(buf, _("irydowe"));
	    break;
	case MAT_KEVLAR:
	    strcpy(buf, _("kevlarowe"));
	    break;
	case MAT_KRYPTONIT:
	    strcpy(buf, _("kryptonitowe"));
	    break;
	case MAT_ADAMANIT:
	    strcpy(buf, _("adamanitowe"));
	    break;
	case MAT_JEDZENIE:
	    strcpy(buf, _(""));
	    break;
	default:
	    strcpy(buf, _("wykonane z nieznanego materiau"));
	    break;
	}
	break;
    case LCZ_MNOGA_II:
	switch (ktorego) {
	case MAT_PLOTNO:
	    strcpy(buf, _("pciennych"));
	    break;
	case MAT_SKORA:
	    strcpy(buf, _("skrzanych"));
	    break;
	case MAT_UTWARDZONA_SKORA:
	    strcpy(buf, _("utwardzonych skrzanych"));
	    break;
	case MAT_DREWNO:
	    strcpy(buf, _("drewnianych"));
	    break;
	case MAT_JEDWAB:
	    strcpy(buf, _("jedwabnych"));
	    break;
	case MAT_SZKLO:
	    strcpy(buf, _("szklanych"));
	    break;
	case MAT_KRYSZTAL:
	    strcpy(buf, _("krysztaowych"));
	    break;
	case MAT_URAN:
	    strcpy(buf, _("uranowych"));
	    break;
	case MAT_PAPIER:
	    strcpy(buf, _("papierowych"));
	    break;
	case MAT_BRAZ:
	    strcpy(buf, _("brzowych"));
	    break;
	case MAT_ZELAZO:
	    strcpy(buf, _("elaznych"));
	    break;
	case MAT_STAL:
	    strcpy(buf, _("stalowych"));
	    break;
	case MAT_SREBRO:
	    strcpy(buf, _("srebrnych"));
	    break;
	case MAT_ZLOTO:
	    strcpy(buf, _("zotych"));
	    break;
	case MAT_CYNA:
	    strcpy(buf, _("cynowych"));
	    break;
	case MAT_OLOW:
	    strcpy(buf, _("oowianych"));
	    break;
	case MAT_ZELIWO:
	    strcpy(buf, _("eliwnych"));
	    break;
	case MAT_MIEDZ:
	    strcpy(buf, _("miedzianych"));
	    break;
	case MAT_CYNK:
	    strcpy(buf, _("cynkowych"));
	    break;
	case MAT_MOSIADZ:
	    strcpy(buf, _("mosinych"));
	    break;
	case MAT_TYTAN:
	    strcpy(buf, _("tytanowych"));
	    break;
	case MAT_IRYD:
	    strcpy(buf, _("irydowych"));
	    break;
	case MAT_KEVLAR:
	    strcpy(buf, _("kevlarowych"));
	    break;
	case MAT_KRYPTONIT:
	    strcpy(buf, _("kryptonitowych"));
	    break;
	case MAT_ADAMANIT:
	    strcpy(buf, _("adamanitowych"));
	    break;
	case MAT_JEDZENIE:
	    strcpy(buf, _(""));
	    break;
	default:
	    strcpy(buf, _("wykonanych z nieznanego materiau"));
	    break;
	}
	break;
    }
    return buf;
}

char *nazwa_przedmiotu(struct przedmiot *P, char *buf, int przypadek)
{
    int liczba = LCZ_POJEDYNCZA;
    char buf2[200];
    if (P->ilosc > 1) {
	liczba++;		/* LCZ_MNOGA */
	if (((P->ilosc % 10) > 4)
	    || (((P->ilosc % 100) > 4) && (P->ilosc % 100 < 22))) {
	    liczba++;
	}
    }
    strcpy(buf, "");
    if (liczba) {
	sprintf(buf, "%d ", P->ilosc);
    }
    if (!(P->flagi & NIE_POKAZUJ_MATERIALU)) {
	strcat(buf,
	       nazwa_materialu(P->material, buf2,
			       przedmiotyID.ID[P->ID].rodzaj, liczba,
			       przypadek));
	strcat(buf, " ");
    }
    if (preID[P->ID].znany || (P->flagi & ZIDENTYFIKOWANY)) {
	switch (liczba) {
	case LCZ_POJEDYNCZA:
	    strcat(buf, przedmiotyID.ID[P->ID].nazwa[przypadek]);
	    break;
	case LCZ_MNOGA:
	    strcat(buf, przedmiotyID.ID[P->ID].mnoga);
	    break;
	case LCZ_MNOGA_II:
	    strcat(buf, przedmiotyID.ID[P->ID].d_mnoga);
	    break;
	}
    } else {
	switch (liczba) {
	case LCZ_POJEDYNCZA:
	    strcat(buf, preID[P->ID].nazwa[przypadek]);
	    break;
	case LCZ_MNOGA:
	    strcat(buf, preID[P->ID].mnoga);
	    break;
	case LCZ_MNOGA_II:
	    strcat(buf, preID[P->ID].d_mnoga);
	    break;
	}
    }
    if (czy_jest_w_strefie(SKLEP, P->x, P->y)) {
	char buf2[50];
	sprintf(buf2, _(" (%d szt. z.)"), P->cena);
	strcat(buf, buf2);
    }
#ifdef DEBUG
    if (pokazuj_parametry) {
	char buf2[50];
	sprintf(buf2, "(%dd%d+%d) {+%d} [%d]", P->wrecz[0], P->wrecz[1],
		P->wrecz[2], P->mod_traf, P->pancerz);
	strcat(buf, buf2);
    }
#endif
    return buf;
}

/* Szukaj przedmiotu o zadanej klasie na licie */
short int
szukaj_przedmiotu_kl(long int klasa, struct przedmioty *Przedmioty)
{
    short int wynik = NIE_ZNALAZL;
    if (!Przedmioty->ile) {
	return wynik;
    }
    for (Przedmioty->aktualny = Przedmioty->poczatek->nast;
	 (Przedmioty->aktualny != Przedmioty->koniec)
	 && (wynik != ZNALAZL);
	 Przedmioty->aktualny = Przedmioty->aktualny->nast) {
	if (przedmiotyID.ID[Przedmioty->aktualny->ID].
	    klasa_przedmiotu & klasa)
	    wynik = ZNALAZL;
    }
    if (wynik == ZNALAZL)
	Przedmioty->aktualny = Przedmioty->aktualny->poprz;
    return wynik;
}

void zdejmij_flagi_z_przedmiotow(struct przedmioty *Py, int flagi)
{
    wskaznik_przedmiot back = Py->aktualny;
    if (!Py->ile)
	return;
    for (Py->aktualny = Py->poczatek->nast;
	 Py->aktualny != Py->koniec; Py->aktualny = Py->aktualny->nast) {
	Py->aktualny->flagi &= ~flagi;
    }
    Py->aktualny = back;
}

/* Zwraca ID przedmiotu o klasie klasa lub -1 jeeli nie znalaz */
int szukaj_przedmiotu_z_klasy(long int klasa, int poziom)
{
    int wynik = -1, tmp, tmp2 = 0, tmp3;
    if (klasa == -1) {
	return wynik;
    }
    for (tmp3 = 0; tmp3 < MAXKLAS; tmp3++) {
	if (klasa & (1 << tmp3)) {
	    tmp2 += Klasa[tmp3][poziom];
	}
    }
    tmp2 = losowa(tmp2);
    for (tmp = 0; (tmp < przedmiotyID.ile && tmp2 > 0); tmp++) {
	if ((przedmiotyID.ID[tmp].klasa_przedmiotu & klasa)
	    && przedmiotyID.ID[tmp].poziom <= poziom) {
	    int tmp3 = przedmiotyID.ID[tmp].czest;
	    tmp2 -= tmp3;
	    if (tmp2 <= 0)
		wynik = tmp;
	}
    }
    return wynik;
}

/* Zwraca ID przedmiotu o klasie klasa wiekszego niz wielkosc lub 
 * -1 jeeli nie znalaz */
int
szukaj_wiekszego_przedmiotu_z_klasy(long int klasa, int podklasa,
				    int poziom, int wielkosc)
{
    int wynik = -1, tmp, tmp2 = 0, tmp3;
    if (klasa == -1 || wielkosc == MAXWIELK) {
	return wynik;
    }
    for (tmp3 = 0; tmp3 < przedmiotyID.ile; tmp3++) {
	if ((klasa & przedmiotyID.ID[tmp3].klasa_przedmiotu) &&
	    (wielkosc < przedmiotyID.ID[tmp3].wielkosc) &&
	    (poziom >= przedmiotyID.ID[tmp3].poziom) && ((podklasa == -1)
							 || (podklasa ==
							     przedmiotyID.
							     ID[tmp3].
							     podklasa_przedmiotu)))
	{
	    tmp2 += przedmiotyID.ID[tmp3].czest;
	}
    }
    tmp2 = losowa(tmp2);
    for (tmp = 0; (tmp < przedmiotyID.ile && tmp2 > 0); tmp++) {
	if ((przedmiotyID.ID[tmp].klasa_przedmiotu & klasa)
	    && przedmiotyID.ID[tmp].poziom <= poziom &&
	    przedmiotyID.ID[tmp].wielkosc > wielkosc && ((podklasa == -1)
							 || (podklasa ==
							     przedmiotyID.
							     ID[tmp].
							     podklasa_przedmiotu)))
	{
	    int tmp3 = przedmiotyID.ID[tmp].czest;
	    tmp2 -= tmp3;
	    if (tmp2 <= 0)
		wynik = tmp;
	}
    }
    return wynik;
}

/* Zwraca ID przedmiotu lub -1 jeeli nie znalaz */
int szukaj_przedmiotu_z_poziomu(int poziom)
{
    int wynik = -1, tmp, tmp2 = 0;
    tmp2 = losowa(suma_pr_prz[poziom]);
    for (tmp = 0; (tmp < przedmiotyID.ile && tmp2 > 0); tmp++) {
	if (przedmiotyID.ID[tmp].poziom <= poziom) {
	    int tmp3 = przedmiotyID.ID[tmp].czest;
	    tmp2 -= tmp3;
	    if (tmp2 <= 0)
		wynik = tmp;
	}
    }
    return wynik;
}

/* Szuka nastpnego przedmiotu na polu (x,y) */
short int szukaj_nastepny(int x, int y, struct przedmioty *Przedmioty)
{
    short int wynik = NIE_ZNALAZL;
    for (Przedmioty->aktualny = Przedmioty->aktualny->nast;
	 ((Przedmioty->aktualny != Przedmioty->koniec)
	  && (Przedmioty->aktualny->x != x)
	  && (Przedmioty->aktualny->y != y));
	 Przedmioty->aktualny = Przedmioty->aktualny->nast);
    if ((Przedmioty->aktualny->x == x) && (Przedmioty->aktualny->y == y))
	wynik = ZNALAZL;
    return wynik;
}

short int znajdz_niezaplacony(struct przedmioty *Przedmioty)
{
    short int wynik = NIE_ZNALAZL;
    if (!Przedmioty->ile)
	return wynik;
    if (Przedmioty->aktualny->nast == Przedmioty->koniec)
	return wynik;
    for (Przedmioty->aktualny = Przedmioty->aktualny->nast;
	 ((Przedmioty->aktualny->nast != Przedmioty->koniec)
	  && (!(Przedmioty->aktualny->flagi & KUPIONE)));
	 Przedmioty->aktualny = Przedmioty->aktualny->nast);
    if (Przedmioty->aktualny->flagi & KUPIONE)
	wynik = ZNALAZL;
    return wynik;
}

/* Szuka przedmiotu o literce literka */
short int szukaj_po_literce(char literka, struct przedmioty *Przedmioty)
{
    short int wynik = NIE_ZNALAZL;
    if (!Przedmioty->ile) {
	return wynik;
    }
    for (Przedmioty->aktualny = Przedmioty->poczatek->nast;
	 (Przedmioty->aktualny != Przedmioty->koniec)
	 && (wynik != ZNALAZL);
	 Przedmioty->aktualny = Przedmioty->aktualny->nast) {
	if (Przedmioty->aktualny->literka == literka)
	    wynik = ZNALAZL;
    }
    if (wynik == ZNALAZL)
	Przedmioty->aktualny = Przedmioty->aktualny->poprz;
    return wynik;
}

int taki_sam(struct przedmiot *L, struct przedmiot *P)
{
    int wynik = 1;
    wynik *= (L->ID == P->ID);
    wynik *= (L->flagi == P->flagi);
    wynik *= (L->material == P->material);
    wynik *= (L->cena == P->cena);
    wynik *= (L->kolor == P->kolor);
    wynik *= (L->mod_traf == P->mod_traf);
    wynik *= (L->pancerz == P->pancerz);
    wynik *= (L->wrecz[0] == P->wrecz[0]);
    wynik *= (L->wrecz[1] == P->wrecz[1]);
    wynik *= (L->wrecz[2] == P->wrecz[2]);
    return wynik;
}

short int szukaj_takiego(struct przedmiot *P, struct przedmioty *Py)
{
    short int wynik = NIE_ZNALAZL;
    if (!Py->ile) {
	return wynik;
    }
    for (Py->aktualny = Py->poczatek->nast;
	 (Py->aktualny != Py->koniec) && (wynik != ZNALAZL);
	 Py->aktualny = Py->aktualny->nast) {
	if (			/*(P->x == -1 && P->y == -1) || */
	       (P->x == Py->aktualny->x && P->y == Py->aktualny->y)) {
	    if (taki_sam(Py->aktualny, P))
		wynik = ZNALAZL;
	}
    }
    if (wynik == ZNALAZL)
	Py->aktualny = Py->aktualny->poprz;
    return wynik;
}

short int szukaj_innego_takiego(struct przedmiot *P, struct przedmioty *Py)
{
    short int wynik = NIE_ZNALAZL;
    if (!Py->ile) {
	return wynik;
    }
    for (Py->aktualny = Py->poczatek->nast;
	 (Py->aktualny != Py->koniec) && (wynik != ZNALAZL);
	 Py->aktualny = Py->aktualny->nast) {
	if ( /*(P->x == -1 && P->y == -1) || */ (Py->aktualny != P)
	    && (P->x == Py->aktualny->x && P->y == Py->aktualny->y)) {
	    if (taki_sam(Py->aktualny, P))
		wynik = ZNALAZL;
	}
    }
    if (wynik == ZNALAZL)
	Py->aktualny = Py->aktualny->poprz;
    return wynik;
}

short int szukaj_tego(wskaznik_przedmiot P, struct przedmioty *Py)
{
    short int wynik = NIE_ZNALAZL;
    if (!Py->ile) {
	return wynik;
    }
    for (Py->aktualny = Py->poczatek->nast;
	 (Py->aktualny != Py->koniec) && (wynik != ZNALAZL);
	 Py->aktualny = Py->aktualny->nast) {
	if (Py->aktualny == P)
	    wynik = ZNALAZL;
    }
    if (wynik == ZNALAZL)
	Py->aktualny = Py->aktualny->poprz;
    return wynik;
}

/* Szuka wolnej litery w plecaku/pojemniku,
 * zwraca znalezion liter,
 * bad 0 w razie niepowodzenia */
char znajdz_wolna_literke(struct przedmioty *Przedmioty)
{
    char wynik = 0;
    int i = 0;
    while (!wynik && i < ILE_LITEREK) {
	if (!Przedmioty->tablica_literek[i]) {
	    wynik = literki[i];
	}
	i++;
    }
    return wynik;
}

/* Zwraca pozycj litery w tablica_literek */
int pozycja_litery(char litera)
{
    int i = 0;
    while (i < ILE_LITEREK && literki[i] != litera)
	i++;
    return i;
}

/* Upuszczanie przedmiotu */
void
poloz_przedmioty(struct przedmioty *Przedm, struct istota *Postac,
		 int ile_polozyc)
{
    char tmp;
/*  int x,y; */
    wskaznik_przedmiot tmp2 = Postac->plecak.aktualny;
    Postac->plecak.aktualny->x = Postac->x;
    Postac->plecak.aktualny->y = Postac->y;
    if (szukaj_takiego(Postac->plecak.aktualny, Przedm) == ZNALAZL) {
	Przedm->aktualny->ilosc += ile_polozyc;
    } else {
	Postac->plecak.aktualny = tmp2;
	dodaj_dokladnie(Postac->x, Postac->y, ile_polozyc,
			Postac->plecak.aktualny, Przedm);
    }
    if (!(Postac->plecak.aktualny->ilosc - ile_polozyc)
	&& Postac->plecak.aktualny->literka != ' ') {
	tmp = Postac->plecak.aktualny->literka;
	Postac->plecak.tablica_literek[pozycja_litery(tmp)] = 0;
    }
    Postac->obciazenie -=
	przedmiotyID.ID[Postac->plecak.aktualny->ID].waga * ile_polozyc;
    usun_przedmiot(&Postac->plecak, ile_polozyc);
}

/* Zwraca literk podniesionego przedmiotu(w) (albo ZLOTO) */
char
podnies_przedmioty(struct przedmioty *Przedmioty, struct istota *Postac,
		   int ile)
{
    char tmp = ' ';
    int x, y;
    wskaznik_przedmiot tmp2 = Postac->plecak.aktualny;
    if (Przedmioty->aktualny->ID == 1) {	/* zo to */
	Postac->au += ile;
	tmp = ZLOTO;
    } else {
	x = Przedmioty->aktualny->x;
	y = Przedmioty->aktualny->y;
	Przedmioty->aktualny->x = -1;
	Przedmioty->aktualny->y = -1;
	if (szukaj_takiego(Przedmioty->aktualny, &Postac->plecak) ==
	    ZNALAZL) {
	    Postac->plecak.aktualny->ilosc += ile;
	    tmp = Postac->plecak.aktualny->literka;
	    Postac->obciazenie +=
		przedmiotyID.ID[Przedmioty->aktualny->ID].waga * ile;
	} else {
	    Postac->plecak.aktualny = tmp2;
	    dodaj_dokladnie((-1), (-1), ile, Przedmioty->aktualny,
			    &Postac->plecak);
	    Postac->obciazenie +=
		przedmiotyID.ID[Przedmioty->aktualny->ID].waga * ile;
	    if ((tmp = znajdz_wolna_literke(&Postac->plecak))) {
		Postac->plecak.aktualny->literka = tmp;
	    } else {
		Postac->plecak.aktualny->literka = ' ';
	    }
	}
	Przedmioty->aktualny->x = x;
	Przedmioty->aktualny->y = y;
    }
    if (Przedmioty->aktualny->strefa != -1) {
	/* Trzeba wycign z tablicy towarw i zapewni jej cigo 
	 *  (pewnie trzeba by to w przeszoci przebudowa, eby jako 
	 *  chronologicznie te towary byy, ale to co jest powinno 
	 *  zapewni stabilno na razie) */
	if (strefa[Przedmioty->aktualny->strefa].typ == SKLEP) {
	    int numer_sklepu = strefa[Przedmioty->aktualny->strefa].numer;
	    sklep[numer_sklepu].towar[numer_w_sklepie
				      (numer_sklepu,
				       Przedmioty->aktualny)] =
		sklep[numer_sklepu].towar[sklep[numer_sklepu].ile_towarow -
					  1];
	    sklep[numer_sklepu].towar[sklep[numer_sklepu].ile_towarow -
				      1] = NULL;
	    sklep[numer_sklepu].ile_towarow--;

	}
    }
    usun_przedmiot(Przedmioty, ile);
    if (tmp != ZLOTO && Postac->plecak.aktualny->literka != ' ')
	Postac->plecak.tablica_literek[pozycja_litery(tmp)] = 1;	/* jeli to ostatni */

    return tmp;
}

void
upusc_przedmiot(struct przedmioty *Przedmioty, struct przedmioty *Plecak,
		int x, int y)
{
    if (Plecak->aktualny->literka != ' ')
	Plecak->
	    tablica_literek[pozycja_litery(Plecak->aktualny->literka)] = 0;
    if (Przedmioty->ile)
	Przedmioty->aktualny = Przedmioty->poczatek->nast;
    dodaj_dokladnie(x, y, 1, Plecak->aktualny, Przedmioty);
    usun_przedmiot(Plecak, 1);
}

/* Dodaje przedmiot z uwzgldnieniem literek */
void
dodaj_z_literkami(struct przedmiot *Przedmiot, struct istota *Postac,
		  int ile)
{
    char tmp;
    wskaznik_przedmiot tmp2 = Postac->plecak.aktualny;
    Postac->plecak.aktualny = tmp2;
    if (!dodaj_ladnie((-1), (-1), ile, Przedmiot->ID, Przedmiot->flagi,
		      Przedmiot->cena, &Postac->plecak)) {
	if ((tmp = znajdz_wolna_literke(&Postac->plecak))) {
	    Postac->plecak.aktualny->literka = tmp;
	    Postac->plecak.tablica_literek[pozycja_litery(tmp)] = 1;
	} else {
	    Postac->plecak.aktualny->literka = ' ';
	}
    }
    Postac->obciazenie += przedmiotyID.ID[Przedmiot->ID].waga * ile;
}

/* Usuwa przedmiot z wyczyszczeniem slotu w tablicy literek */
void zniszcz_przedmiot(struct przedmioty *Przedmioty)
{
    if (Przedmioty->aktualny->literka != ' ')
	Przedmioty->tablica_literek[pozycja_litery
				    (Przedmioty->aktualny->literka)] = 0;
    usun_przedmiot(Przedmioty, -1);
}

void usun_z_plecaka_przedmiot(struct przedmioty *Przedmioty)
{
    char lit;
    lit = Przedmioty->aktualny->literka;
    if (!usun_przedmiot(Przedmioty, 1) && lit != ' ')
	Przedmioty->tablica_literek[pozycja_litery(lit)] = 0;
}

/* Usuwa ile przedmiotw (albo wszystkie, jeli ile>Przedmioty->aktualny->ilosc
 * Przedmioty->aktualny lub ile=-1) z listy i zwraca pozosta ilo 
 * przedmiotw tego typu) */
int usun_przedmiot(struct przedmioty *Przedmioty, int ile)
{
    Przedmioty->aktualny->ilosc -= ile;
    if (Przedmioty->aktualny->ilosc < 0 || ile == -1)
	Przedmioty->aktualny->ilosc = 0;
    if (!Przedmioty->aktualny->ilosc) {
	Przedmioty->aktualny->poprz->nast = Przedmioty->aktualny->nast;
	Przedmioty->aktualny->nast->poprz = Przedmioty->aktualny->poprz;
	my_free(Przedmioty->aktualny);
	Przedmioty->aktualny = Przedmioty->poczatek->nast;
	Przedmioty->ile--;
	return 0;
    }
    return Przedmioty->aktualny->ilosc;
}

/* Dodaje przedmiot tak, eby lista bya posortowana
 * wzgldem pooenia przedmiotw */
int
dodaj_ladnie(int x, int y, int ilosc, int ID, int flagi, int cena,
	     struct przedmioty *Przedmioty)
{
    if (flagi == -1) {
	flagi = przedmiotyID.ID[ID].flagi;
    }
    if (Przedmioty->ile == 0)
	dodaj_przedmiot(x, y, ilosc, ID, flagi, Przedmioty);
    else {
	wskaznik_przedmiot tmp;
	Przedmioty->aktualny = Przedmioty->poczatek->nast;
	while (((MAXX + 1) * Przedmioty->aktualny->y +
		Przedmioty->aktualny->x <= (MAXX + 1) * y + x)
	       && (Przedmioty->aktualny != Przedmioty->koniec))
	    Przedmioty->aktualny = Przedmioty->aktualny->nast;
	Przedmioty->aktualny = Przedmioty->aktualny->poprz;
	dodaj_przedmiot(x, y, ilosc, ID, flagi, Przedmioty);
	tmp = Przedmioty->aktualny;
	if (cena != -1)
	    tmp->cena = cena;
	if (szukaj_innego_takiego(Przedmioty->aktualny, Przedmioty) ==
	    ZNALAZL) {
	    Przedmioty->aktualny->ilosc += tmp->ilosc;
	    Przedmioty->aktualny = tmp;
	    usun_przedmiot(Przedmioty, tmp->ilosc);
	    return 1;
	}
	Przedmioty->aktualny = tmp;
    }
    if (cena != -1)
	Przedmioty->aktualny->cena = cena;
    return 0;
}

int
dodaj_dokladnie(int x, int y, int ile, struct przedmiot *co,
		struct przedmioty *gdzie)
{
    dodaj_ladnie(x, y, ile, co->ID, co->flagi, co->cena, gdzie);
    gdzie->aktualny->material = co->material;
    gdzie->aktualny->wrecz[0] = co->wrecz[0];
    gdzie->aktualny->wrecz[1] = co->wrecz[1];
    gdzie->aktualny->wrecz[2] = co->wrecz[2];
    gdzie->aktualny->pancerz = co->pancerz;
    gdzie->aktualny->mod_traf = co->mod_traf;
    gdzie->aktualny->cena = co->cena;
    gdzie->aktualny->kolor = co->kolor;
    return 0;
}

int
dodaj_dokladnie_z_literkami(struct przedmiot *co, struct istota *komu,
			    int ile)
{
    dodaj_z_literkami(co, komu, ile);
    komu->plecak.aktualny->material = co->material;
    komu->plecak.aktualny->wrecz[0] = co->wrecz[0];
    komu->plecak.aktualny->wrecz[1] = co->wrecz[1];
    komu->plecak.aktualny->wrecz[2] = co->wrecz[2];
    komu->plecak.aktualny->mod_traf = co->mod_traf;
    komu->plecak.aktualny->pancerz = co->pancerz;
    komu->plecak.aktualny->cena = co->cena;
    komu->plecak.aktualny->kolor = co->kolor;
    return 0;
}

int wybierz_material(int ID, int poziom)
{
    int wynik = -1, i, czest;
    long int k = losowa(przedmiotyID.ID[ID].mat_sum);
    for (i = 0; (i < MAXMATERIALOW && wynik == -1); i++) {
	if (przedmiotyID.ID[ID].material[i][1] <= poziom) {
	    czest =
		przedmiotyID.ID[ID].material[i][0] + (poziom -
						      przedmiotyID.ID[ID].
						      material[i]
						      [1]) *
		przedmiotyID.ID[ID].material[i][2];
	    k -= czest;
	    if (k <= 0) {
		wynik = i;
	    }
	}
    }
    if (wynik == -1) {
#ifdef DEBUG
	dodaj_napis(_("Bd przy wybieraniu materiau. "));
#endif
	wynik = MAT_ZELAZO;
    }
    return wynik;
}

/* Proste dodanie przedmiotu */
int
dodaj_przedmiot(int x, int y, int ilosc, int ID, int flagi,
		struct przedmioty *Przedmioty)
{
    if (!Przedmioty->ile) {
	Przedmioty->aktualny = my_malloc(sizeof(Przedmiot));
	Przedmioty->poczatek = my_malloc(sizeof(Przedmiot));
	Przedmioty->koniec = my_malloc(sizeof(Przedmiot));
	Przedmioty->koniec->x = (1000);
	Przedmioty->koniec->y = (1000);
	Przedmioty->poczatek->x = (-3);
	Przedmioty->poczatek->y = (-3);
	Przedmioty->koniec->poprz = Przedmioty->aktualny;
	Przedmioty->koniec->nast = NULL;
	Przedmioty->poczatek->nast = Przedmioty->aktualny;
	Przedmioty->poczatek->poprz = NULL;
	Przedmioty->aktualny->poprz = Przedmioty->poczatek;
	Przedmioty->aktualny->x = x;
	Przedmioty->aktualny->y = y;
	Przedmioty->aktualny->ilosc = ilosc;
	Przedmioty->aktualny->ID = ID;
	Przedmioty->aktualny->nast = Przedmioty->koniec;
	Przedmioty->ile++;
    } else {
	wskaznik_przedmiot dodawany;
	dodawany = my_malloc(sizeof(Przedmiot));
	dodawany->nast = Przedmioty->aktualny->nast;
	Przedmioty->aktualny->nast = dodawany;
	if (dodawany->nast != NULL)
	    dodawany->nast->poprz = dodawany;
	dodawany->poprz = Przedmioty->aktualny;
	Przedmioty->aktualny = Przedmioty->aktualny->nast;
	Przedmioty->aktualny->x = x;
	Przedmioty->aktualny->y = y;
	Przedmioty->aktualny->ilosc = ilosc;
	Przedmioty->aktualny->ID = ID;
	Przedmioty->ile++;
    }
    Przedmioty->aktualny->flagi = flagi;
    zrob_przedmiot(Przedmioty->aktualny);
    return 0;
}

void zrob_przedmiot(struct przedmiot *P)
{
    int ID = P->ID;
    P->material = wybierz_material(ID, Poziom.poziom);
    P->strefa = -1;
    P->bazowy = NULL;
    P->cena = (przedmiotyID.ID[ID].cena * (100 +
					   losowaoddo(material
						      [P->material].
						      mod_ceny[0],
						      material[P->
							       material].
						      mod_ceny[1]))) / 100;
    if (przedmiotyID.ID[ID].klasa_przedmiotu & KL_NAPOJ) {
	P->kolor = przedmiotyID.ID[ID].kolor;
    } else {
	P->kolor = material[P->material].kolor;
    }
    if (przedmiotyID.ID[ID].klasa_przedmiotu & KL_KSIAZKA)
	P->kolor = K_BRAZOWY;
    P->pancerz =
	(przedmiotyID.ID[ID].pancerz *
	 (100 +
	  losowaoddo(material[P->material].pancerz[0],
		     material[P->material].pancerz[1]))) / 100;
    P->wrecz[0] =
	(losowaoddo
	 (przedmiotyID.ID[ID].wrecz[0][0],
	  przedmiotyID.ID[ID].wrecz[0][1]) * (100 +
					      losowaoddo(material
							 [P->material].
							 wrecz[0][0],
							 material[P->
								  material].
							 wrecz[0][1]))) /
	100;
    P->wrecz[1] =
	(losowaoddo
	 (przedmiotyID.ID[ID].wrecz[1][0],
	  przedmiotyID.ID[ID].wrecz[1][1]) * (100 +
					      losowaoddo(material
							 [P->material].
							 wrecz[1][0],
							 material[P->
								  material].
							 wrecz[1][1]))) /
	100;
    P->wrecz[2] =
	(losowaoddo
	 (przedmiotyID.ID[ID].wrecz[2][0],
	  przedmiotyID.ID[ID].wrecz[2][1]) * (100 +
					      losowaoddo(material
							 [P->material].
							 wrecz[2][0],
							 material[P->
								  material].
							 wrecz[2][1]))) /
	100;
    P->mod_traf =
	(losowaoddo
	 (przedmiotyID.ID[ID].mod_traf[0],
	  przedmiotyID.ID[ID].mod_traf[1]) * (100 +
					      losowaoddo(material
							 [P->material].
							 mod_traf[0],
							 material[P->
								  material].
							 mod_traf[1]))) /
	100;
}

/* Wczytuje tablic waciwoci przedmiotw */
void wczytaj_tablice_prz_ID(struct _plik *in, struct PrzedmiotyID *tablica)
{
    int i, j, k;
    /* Czycimy tablic klas */
    for (i = 0; i <= MAXKLAS; i++)
	for (j = 0; j <= MAXPOZ; j++)
	    Klasa[i][j] = 0;

    for (i = 0; i <= MAXPOZ; i++)
	suma_pr_prz[i] = 0;

    /* Tablica znanych */
    for (i = 0; i < MAXPRZEDM; i++)
	preID[i].znany = 0;

    sread(in, &tablica->ile, sizeof(tablica->ile));

    for (i = 0; i < tablica->ile; i++) {
	sread(in, &tablica->ID[i], sizeof(struct przedmiotID));
	/* Tablice znanych */
	{
	    int juz = 0;
	    if (tablica->ID[i].klasa_przedmiotu & KL_NAPOJ) {
		j = wybierz_z_napojow_preID();
		for (k = 0; k < MAXPRZYP; k++)
		    strcpy(preID[i].nazwa[k], napoje_preID.nazwa[k][j]);
		strcpy(preID[i].mnoga, napoje_preID.mnoga[j]);
		strcpy(preID[i].d_mnoga, napoje_preID.d_mnoga[j]);
		tablica->ID[i].kolor = napoje_preID.kolor[j];
		juz = 1;
	    }
	    if (tablica->ID[i].klasa_przedmiotu & KL_ZWOJ) {
		j = wybierz_ze_zwojow_preID();
		for (k = 0; k < MAXPRZYP; k++)
		    strcpy(preID[i].nazwa[k], zwoje_preID.nazwa[k][j]);
		strcpy(preID[i].mnoga, zwoje_preID.mnoga[j]);
		strcpy(preID[i].d_mnoga, zwoje_preID.d_mnoga[j]);
		juz = 1;
	    }
	    if (!juz) {
		for (k = 0; k < MAXPRZYP; k++)
		    strcpy(preID[i].nazwa[k], tablica->ID[i].nazwa[k]);
		strcpy(preID[i].mnoga, tablica->ID[i].mnoga);
		strcpy(preID[i].d_mnoga, tablica->ID[i].d_mnoga);
	    }
	}
	/* Tablice czstoci */
	for (j = tablica->ID[i].poziom; j <= MAXPOZ; j++) {

	    suma_pr_prz[j] += tablica->ID[i].czest;

	    for (k = 0; k <= MAXKLAS; k++)
		if (tablica->ID[i].klasa_przedmiotu & (1 << k))
		    Klasa[k][j] += tablica->ID[i].czest;

	}
    }
}

void wczytaj_tablice_preID(struct _plik *in)
{
    sread(in, &napoje_preID, sizeof(napoje_preID));
    sread(in, &zwoje_preID, sizeof(zwoje_preID));
}

void zapisz_tablice_wyk_preID(char *out, long int *ile)
{
    int i;
    (*ile) = 0;
    memcpy(&out[*ile], &napoje_preID.wykorzystany,
	   sizeof(napoje_preID.wykorzystany));
    (*ile) += sizeof(napoje_preID.wykorzystany);
    memcpy(&out[*ile], &zwoje_preID.wykorzystany,
	   sizeof(zwoje_preID.wykorzystany));
    (*ile) += sizeof(zwoje_preID.wykorzystany);
/* XXX Kolory */
    for (i = 0; i < MAXPRZEDM; i++) {
	memcpy(&out[*ile], &przedmiotyID.ID[i].kolor,
	       sizeof(przedmiotyID.ID[i].kolor));
	(*ile) += sizeof(przedmiotyID.ID[i].kolor);
    }
}

void wczytaj_tablice_wyk_preID(struct _plik *in)
{
    int i;
    sread(in, &napoje_preID.wykorzystany,
	  sizeof(napoje_preID.wykorzystany));
    sread(in, &zwoje_preID.wykorzystany, sizeof(zwoje_preID.wykorzystany));
    for (i = 0; i < MAXPRZEDM; i++)
	sread(in, &przedmiotyID.ID[i].kolor,
	      sizeof(przedmiotyID.ID[i].kolor));
}

/* Zapisuje tablic waciwoci przedmiotw */
void
zapisz_tablice_prz_ID(char *out, long int *ile,
		      struct PrzedmiotyID tablica)
{
    int i;
    *ile = 0;
    memcpy(&out[*ile], &tablica.ile, sizeof(tablica.ile));
    (*ile) += sizeof(tablica.ile);
    for (i = 0; i < tablica.ile; i++) {
	memcpy(&out[*ile], &tablica.ID[i], sizeof(struct przedmiotID));
	(*ile) += sizeof(struct przedmiotID);
    }
}

void wczytaj_tablice_znanych(struct _plik *in)
{
    int i;
    for (i = 0; i < MAXPRZEDM; i++)
	sread(in, &preID[i].znany, sizeof(preID[i].znany));
}

void zapisz_tablice_znanych(char *out, long int *ile)
{
    int i;
    (*ile) = 0;
    for (i = 0; i < MAXPRZEDM; i++) {
	memcpy(&out[*ile], &preID[i].znany, sizeof(preID[i].znany));
	(*ile) += sizeof(preID[i].znany);
    }
/*	fprintf(stderr, "z_t_z:%db\n", *ile); */
}

/* Tworzy list przedmiotw w/g tego co w pliku  */
void wczytaj_przedmioty(struct _plik *in, struct przedmioty *Przedmioty)
{
    int i;
    struct przedmiot_IO rekord;
    sread(in, &i, sizeof(int));
    sread(in, &Przedmioty->tablica_literek,
	  ILE_LITEREK * sizeof(short int));
    while (Przedmioty->ile < i) {
	sread(in, &rekord, sizeof(struct przedmiot_IO));
	dodaj_ladnie(rekord.x, rekord.y, rekord.ilosc, rekord.ID, -1, -1,
		     Przedmioty);
	Przedmioty->aktualny->wrecz[0] = rekord.wrecz[0];
	Przedmioty->aktualny->wrecz[1] = rekord.wrecz[1];
	Przedmioty->aktualny->wrecz[2] = rekord.wrecz[2];
	Przedmioty->aktualny->material = rekord.material;
	Przedmioty->aktualny->mod_traf = rekord.mod_traf;
	Przedmioty->aktualny->strefa = rekord.strefa;
	Przedmioty->aktualny->literka = rekord.literka;
	Przedmioty->aktualny->pancerz = rekord.pancerz;
	Przedmioty->aktualny->cena = rekord.cena;
	Przedmioty->aktualny->kolor = rekord.kolor;
	Przedmioty->aktualny->flagi = rekord.flagi;
	/* XXX */
	if (rekord.flagi & CZESC)
	    Przedmioty->aktualny->bazowy = Przedmioty->aktualny->poprz;
	if (rekord.strefa != -1) {
	    if (strefa[rekord.strefa].typ == SKLEP) {
		sklep[strefa[rekord.strefa].
		      numer].towar[sklep[strefa[rekord.strefa].numer].
				   ile_towarow] = Przedmioty->aktualny;
		sklep[strefa[rekord.strefa].numer].ile_towarow++;
	    }
	}
    }
}

void wczytaj_przedmioty_kr(struct _plik *in, struct przedmioty *Przedmioty)
{
    int i;
    struct przedmiot_IO_kr rekord;
    sread(in, &i, sizeof(int));
    while (Przedmioty->ile < i) {
	sread(in, &rekord, sizeof(struct przedmiot_IO_kr));
	dodaj_ladnie(rekord.x, rekord.y, rekord.ilosc, rekord.ID, -1, -1,
		     Przedmioty);
    }
}

/* Zapisuje do pliku liste przedmiotw */
void
zapisz_przedmioty(char *out, long int *ile, struct przedmioty *Przedmioty)
{
    int i;
    struct przedmiot_IO rekord;
    *ile = 0;
    memcpy(&out[*ile], &Przedmioty->ile, sizeof(Przedmioty->ile));
    (*ile) += sizeof(Przedmioty->ile);
    memcpy(&out[*ile], &Przedmioty->tablica_literek,
	   ILE_LITEREK * sizeof(short int));
    (*ile) += ILE_LITEREK * sizeof(short int);
    i = 0;
    if (Przedmioty->ile < 1) {
	return;
    }
    Przedmioty->aktualny = Przedmioty->poczatek;
    while (i < Przedmioty->ile) {
	Przedmioty->aktualny = Przedmioty->aktualny->nast;
	rekord.x = Przedmioty->aktualny->x;
	rekord.y = Przedmioty->aktualny->y;
	rekord.ID = Przedmioty->aktualny->ID;
	rekord.material = Przedmioty->aktualny->material;
	rekord.wrecz[0] = Przedmioty->aktualny->wrecz[0];
	rekord.wrecz[1] = Przedmioty->aktualny->wrecz[1];
	rekord.wrecz[2] = Przedmioty->aktualny->wrecz[2];
	rekord.mod_traf = Przedmioty->aktualny->mod_traf;
	rekord.kolor = Przedmioty->aktualny->kolor;
	rekord.cena = Przedmioty->aktualny->cena;
	rekord.ilosc = Przedmioty->aktualny->ilosc;
	rekord.strefa = Przedmioty->aktualny->strefa;
	rekord.literka = Przedmioty->aktualny->literka;
	rekord.pancerz = Przedmioty->aktualny->literka;
	rekord.flagi = Przedmioty->aktualny->flagi;
	memcpy(&out[*ile], &rekord, sizeof(struct przedmiot_IO));
	(*ile) += sizeof(struct przedmiot_IO);
	i++;
    }
}

void wyczysc_liste_przedmiotow(struct przedmioty *Przedmioty)
{
    if (Przedmioty->ile < 1) {
	return;
    }
    Przedmioty->aktualny = Przedmioty->poczatek->nast;
    while (Przedmioty->aktualny != Przedmioty->koniec) {
	usun_przedmiot(Przedmioty, 1);
	Przedmioty->aktualny = Przedmioty->poczatek->nast;
    }
}

int wybierz_z_napojow_preID()
{
    int i, koniec = 0;
    while (!koniec) {
	i = losowaoddo(0, napoje_preID.ile - 1);
	koniec = !napoje_preID.wykorzystany[i];
    }
    napoje_preID.wykorzystany[i] = 1;
    return i;
}

int wybierz_ze_zwojow_preID()
{
    int i, koniec = 0;
    while (!koniec) {
	i = losowaoddo(0, zwoje_preID.ile - 1);
	koniec = !zwoje_preID.wykorzystany[i];
    }
    zwoje_preID.wykorzystany[i] = 1;
    return i;
}

long int dozwolone_klasy(int miejsce)
{
    long int wynik = 0;
    switch (miejsce) {
    case GLOWAS...GLOWAK:
	wynik = KL_NAKR_GLOWY;
	break;
    case REKAS...REKAK:
	wynik = KL_WSZYSTKIE;
	break;
    case KORPUSS...KORPUSK:
	wynik = KL_PANCERZ;
	break;
    case NOGAS...NOGAK:
	wynik = KL_BUTY;
	break;
    }
    return wynik;
}

int sprawdz_czy_mozna_uzyc(int ID, int gdzie, struct istota *Postac)
{
    int klasa = przedmiotyID.ID[ID].klasa_przedmiotu, wynik = 0, dwur =
	(klasa & KL_BR_DWUR);
    wynik = klasa & dozwolone_klasy(gdzie);
    if (dwur)
	wynik *= klasa & dozwolone_klasy(gdzie + 1);
    if (Postac->ekw.miejsce[gdzie].ile)
	if (przedmiotyID.ID[ID].wielkosc <=
	    przedmiotyID.ID[Postac->ekw.miejsce[gdzie].koniec->poprz->
			    ID].wielkosc)
	    wynik = 0;
    if (dwur)
	if (Postac->ekw.miejsce[gdzie + 1].ile)
	    if (przedmiotyID.ID[ID].wielkosc <=
		przedmiotyID.ID[Postac->ekw.miejsce[gdzie + 1].koniec->
				poprz->ID].wielkosc)
		wynik = 0;
    return wynik;
}

void dodaj_do_ekwipunku(struct istota *Postac, int miejsce)
{
    char czc[20], co = ' ';
    przesun_kursor(10, 15);
    switch (miejsce) {
    case GLOWAS...GLOWAK:
	sprintf(czc, _("Gowa"));
	break;
    case SZYJAS...SZYJAK:
	sprintf(czc, _("Szyja"));
	break;
    case REKAS...REKAK:
	sprintf(czc, _("Rka"));
	break;
    case KORPUSS...KORPUSK:
	sprintf(czc, _("Tuw"));
	break;
    case NOGAS...NOGAK:
	sprintf(czc, _("Noga"));
	break;
    default:
	break;
    }
    wprintw(wEkran, _("%s: Co chcesz woy? (enter - pena lista) "),
	    czc);
    wrefresh(wEkran);
    co = pobierz_klawisz();
    if (co != '\r') {
	if (szukaj_po_literce(co, &Postac->plecak) != ZNALAZL) {
	    przesun_kursor(20, 17);
	    wprintw(wEkran,
		    _("Nie masz takiego przedmiotu.\n\nNacinij co!"));
	    wrefresh(wEkran);
	    pobierz_klawisz();
	} else {
	    if (sprawdz_czy_mozna_uzyc
		(Postac->plecak.aktualny->ID, miejsce, Postac)
		&& (!(Postac->plecak.aktualny->flagi & KUPIONE))) {
		if (Postac->ekw.miejsce[miejsce].ile)
		    Postac->ekw.miejsce[miejsce].aktualny =
			Postac->ekw.miejsce[miejsce].koniec->poprz;
		dodaj_dokladnie(-1, -1, /*XXX*/ 1, Postac->plecak.aktualny,
				&Postac->ekw.miejsce[miejsce]);
		if (przedmiotyID.ID[Postac->plecak.aktualny->ID].
		    klasa_przedmiotu & KL_BR_DWUR) {
		    if (Postac->ekw.miejsce[miejsce + 1].ile)
			Postac->ekw.miejsce[miejsce + 1].aktualny =
			    Postac->ekw.miejsce[miejsce + 1].koniec->poprz;
		    dodaj_dokladnie(-1, -1, /*XXX*/ 1,
				    Postac->plecak.aktualny,
				    &Postac->ekw.miejsce[miejsce + 1]);
		    Postac->ekw.miejsce[miejsce + 1].aktualny->flagi |=
			CZESC;

		}
		usun_z_plecaka_przedmiot(&Postac->plecak);
	    }
	}
    } else {
	wybierz_przedmiot(&Postac->plecak, 0, WSZYSTKIE_FLAGI,
			  dozwolone_klasy(miejsce));
	if (Postac->plecak.aktualny == NULL) {
	    /*
	       przesun_kursor(20, 17);
	       wprintw(wEkran, _("Twj plecak jest pusty!\nNacinij co!"));
	       wrefresh(wEkran);
	       pobierz_klawisz(); */
	    return;
	}
	if (sprawdz_czy_mozna_uzyc
	    (Postac->plecak.aktualny->ID, miejsce, Postac)
	    && (!(Postac->plecak.aktualny->flagi & KUPIONE))) {
	    if (Postac->ekw.miejsce[miejsce].ile)
		if (Postac->ekw.miejsce[miejsce].ile)
		    Postac->ekw.miejsce[miejsce].aktualny =
			Postac->ekw.miejsce[miejsce].koniec->poprz;
	    dodaj_dokladnie(-1, -1, /*XXX*/ 1, Postac->plecak.aktualny,
			    &Postac->ekw.miejsce[miejsce]);
	    if (przedmiotyID.ID[Postac->plecak.aktualny->ID].
		klasa_przedmiotu & KL_BR_DWUR) {
		if (Postac->ekw.miejsce[miejsce + 1].ile)
		    Postac->ekw.miejsce[miejsce + 1].aktualny =
			Postac->ekw.miejsce[miejsce + 1].koniec->poprz;
		dodaj_dokladnie(-1, -1, /*XXX*/ 1, Postac->plecak.aktualny,
				&Postac->ekw.miejsce[miejsce + 1]);
		Postac->ekw.miejsce[miejsce + 1].aktualny->flagi |= CZESC;

	    }
	    usun_z_plecaka_przedmiot(&Postac->plecak);
	}
    }

}

void wyjmij_z_ekwipunku(struct istota *Postac, int miejsce)
{
    if (!Postac->ekw.miejsce[miejsce].ile)
	return;
    if (Postac->ekw.miejsce[miejsce].koniec->poprz->flagi & CZESC)
	return;
    dodaj_dokladnie_z_literkami(Postac->ekw.miejsce[miejsce].koniec->poprz,
				Postac, 1);
    Postac->ekw.miejsce[miejsce].aktualny =
	Postac->ekw.miejsce[miejsce].koniec->poprz;
    if (przedmiotyID.ID[Postac->ekw.miejsce[miejsce].aktualny->ID].
	klasa_przedmiotu & KL_BR_DWUR) {
	Postac->ekw.miejsce[miejsce + 1].aktualny =
	    Postac->ekw.miejsce[miejsce + 1].koniec->poprz;
	zniszcz_przedmiot(&Postac->ekw.miejsce[miejsce + 1]);
    }
    zniszcz_przedmiot(&Postac->ekw.miejsce[miejsce]);
}

/* To jest szybka_i_brzydka funkcja, ktra bez adnych ceregieli zrzuca 
 * zawarto ekwipunku na ziemie. Do uycia wycznie przy zgonie, jeli 
 * oczywicie lekarz nie zaleci inaczej */
void upusc_ekwipunek(struct istota *Postac, struct przedmioty *Gdzie)
{
    int m;
    for (m = 0; m < MAXMEKW; m++) {
	if (Postac->ekw.miejsce[m].ile)
	    Postac->ekw.miejsce[m].aktualny =
		Postac->ekw.miejsce[m].poczatek->nast;
	while (Postac->ekw.miejsce[m].ile)
	    upusc_przedmiot(Gdzie, &Postac->ekw.miejsce[m], Postac->x,
			    Postac->y);
    }
}

int uszkodzenie_przedmiotu(struct przedmiot *P, int sila)
{
    P->pancerz -= sila / 10;
    return sila;
}

void policz_czestosci(int poziom, struct PrzedmiotyID *P)
{
    int i, j, cz;
    for (i = 0; i < P->ile; i++) {
	cz = 0;
	for (j = 0; j < MAXMATERIALOW; j++) {
	    int c1 = P->ID[i].material[j][0];
	    int c2 = P->ID[i].material[j][1];
	    int c3 = P->ID[i].material[j][2];
	    if (c2 <= poziom) {
		cz += c1 + (poziom - c2) * c3;
	    }
	}
	P->ID[i].mat_sum = cz;
    }
}

void init_materialow()
{
    ustaw_plik(&Plik, "MATE0G");
    sread(&Plik, &material, MAXMATERIALOW * sizeof(struct _material));
}

int gr_podnies_przedmioty(struct poziom *Poziom, struct istota *Postac)
{
    int koncz_runde = 1, ile_podniesc;
    char _napis[1000];
    char temp[100], temp2[100];
    int w_sklepie = czy_jest_w_strefie(SKLEP, Postac->x,
				       Postac->y);

    if (szukaj_przedmiotu
	(Postac->x, Postac->y, &Poziom->Przedmioty) == ZNALAZL) {
	char literka;
	int ile_tam_jest = Poziom->Przedmioty.aktualny->ilosc;
	if (ile_tam_jest == 1) {
	    ile_podniesc = 1;
	} else {
	    sprintf(_napis, _("Ile podnie (%s) ? (1-[%d]) "),
		    przedmiotyID.ID[Poziom->Przedmioty.aktualny->ID].mnoga,
		    ile_tam_jest);
	    dodaj_napis(_napis);
	    ile_podniesc = pobierz_liczbe();
	    if (ile_podniesc < 1 || ile_podniesc > ile_tam_jest) {
		ile_podniesc = ile_tam_jest;
	    };
	}
	if (w_sklepie) {
	    /* XXX Wszystkie przedmioty tego typu lece na ziemi: */
	    Poziom->Przedmioty.aktualny->flagi |= KUPIONE;
	}
	literka =
	    podnies_przedmioty(&Poziom->Przedmioty, Postac, ile_podniesc);
	if (w_sklepie) {
	    strefa[numer_strefy(SKLEP, Postac->x, Postac->y)].licznik +=
		ile_podniesc;
#ifdef DEBUG
	    sprintf(_napis, "%d ",
		    strefa[numer_strefy
			   (SKLEP, Postac->x, Postac->y)].licznik);
#endif
	}
	if (literka == ZLOTO) {
	    struct przedmiot P;
	    P.ID = PRZ_ZLOTO;
	    P.ilosc = ile_podniesc;
	    P.flagi = przedmiotyID.ID[PRZ_ZLOTO].flagi;
	    sprintf(temp, _("Masz %s. "),
		    nazwa_przedmiotu(&P, temp2, PRZYP_BIERNIK));
	} else {
	    if (literka == ' ') {
		sprintf(temp, _("Masz %s. "),
			nazwa_przedmiotu(Postac->plecak.aktualny, temp2,
					 PRZYP_BIERNIK));
	    } else {
		sprintf(temp, _("Masz %s (%c). "),
			nazwa_przedmiotu(Postac->plecak.aktualny, temp2,
					 PRZYP_BIERNIK), literka);
	    }
	}
	dodaj_napis(temp);
	wyswietl_opis_gracza(Poziom);
	wrefresh(wOpis);
	przerysuj = TRUE;
    } else {
	dodaj_napis(_("Tu nic nie ley! "));
	koncz_runde = 0;
    }
    return koncz_runde;
}

int gr_poloz_przedmioty(struct poziom *Poziom, struct istota *Postac)
{
    int koncz_runde = 1;
    char _napis[25], literka, temp[100], temp2[100];
    int w_sklepie =
	czy_jest_w_strefie(SKLEP, Postac->x, Postac->y), ile_polozyc,
	ile_masz;
    dodaj_napis(_("Co chcesz upuci? (ENTER - lista) "));
    if (!wybierz_przedmiot
	(&Postac->plecak, 1, WSZYSTKIE_FLAGI, KL_WSZYSTKIE)) {
	koncz_runde = 0;
	return 0;
    }
    wyczysc_gore();
    rysuj_poziom(Poziom);
    rysuj_przedmioty(Poziom, &Poziom->Przedmioty);
    rysuj_postacie(Poziom);
    wyswietl_opis(Postac);
    wrefresh(wPoziom);
    wrefresh(wOpis);
    if (Postac->plecak.aktualny == NULL) {
	dodaj_napis(_("Twj plecak jest pusty. "));
	return 0;
    }
    ile_masz = Postac->plecak.aktualny->ilosc;
    if (w_sklepie && !(Postac->plecak.aktualny->flagi & KUPIONE)) {
	/* XXX - nie ma sprzedawania */
	dodaj_napis(_
		    ("W sklepie moesz odoy jedynie przedmioty, za ktre jeszcze nie zapacie - jak na razie! "));
	return 0;
    }
    if (ile_masz == 1) {
	ile_polozyc = 1;
    } else {
	sprintf(_napis, _("Ile poloy? (1-[%d]) "), ile_masz);
	dodaj_napis(_napis);
	ile_polozyc = pobierz_liczbe();
	if (!ile_polozyc)
	    return 0;
	if (ile_polozyc < 1 || ile_polozyc > ile_masz)
	    ile_polozyc = ile_masz;
    }
    literka = Postac->plecak.aktualny->literka;
    if (w_sklepie)
	strefa[numer_strefy(SKLEP, Postac->x, Postac->y)].licznik -=
	    ile_polozyc;
    if (literka == ZLOTO) {
	sprintf(temp, _("Pooye troch zota. "));
    } else {
	if (literka == ' ') {
	    sprintf(temp,
		    _
		    ("Pooye sobie %s. "),
		    nazwa_przedmiotu(Postac->plecak.aktualny, temp2,
				     PRZYP_BIERNIK));
	} else {
	    sprintf(temp,
		    _
		    ("Pooye sobie %s (%c). "),
		    nazwa_przedmiotu(Postac->plecak.aktualny, temp2,
				     PRZYP_BIERNIK), literka);
	}
    }
    dodaj_napis(temp);
    poloz_przedmioty(&Poziom->Przedmioty, Postac, ile_polozyc);
    wyswietl_opis_gracza(Poziom);
    wrefresh(wOpis);
    przerysuj = TRUE;
    return koncz_runde;
}
