/* schematekwipunku.h */
#ifndef SCHEMAT_EKWIPUNKU_H
#define SCHEMAT_EKWIPUNKU_H
#include "config.h"
#include "io.h"
#include "structpostac.h"
#include "structprzedmiotyID.h"
#include "przedmioty.h"

struct schemat_ekwipunku {
    int miejsce[MAXMEKW][MAXPSCH];	/* Klasy przedmiotw */
    int miejsce_podkl[MAXMEKW][MAXPSCH];	/* Podklasy przedmiotw lub 1000 + ID */
    int plecak[MAXPL];
} sch_ekw[MAXSCH];

int ile_schematow_ekwipunku;

void wczytaj_schematy_ekwipunku(struct _plik *in,
				struct schemat_ekwipunku *schemat);

void zapisz_schematy_ekwipunku(char *out, long int *ile,
			       struct schemat_ekwipunku *schemat);

void zrob_ekwipunek(struct istota *P, int poziom);
#endif
