/*structprzedmioty.h */
#ifndef struct_przedmioty_h
#define struct_przedmioty_h

#include "config.h"

typedef struct przedmiot *wskaznik_przedmiot;

struct przedmiot {
    int x, y;			/* x,y - pooenie */
    int kolor;
    int ID;			/* indeks w tablicy waciwoci przedmiotw */
    int ilosc;
    int flagi;
    int cena;
    int material;
    int wrecz[3], mod_traf;
    int strefa;			/* -1, jeeli nie naley do adnej */
    int pancerz;
    wskaznik_przedmiot nast;
    wskaznik_przedmiot poprz;
    wskaznik_przedmiot bazowy;	/* Do przedmiotw skadajcych si z czci (bronie dwurczne) */
    char literka;		/* litera w plecaku, ' ' jeeli nie posiada */

};

/* Skrcona, do pliku ze stanem poziomu */
struct przedmiot_IO {
    int x, y;
    int ilosc;
    int material;
    int ID;
    int wrecz[3], mod_traf;
    int pancerz;
    int strefa;
    int cena;
    int kolor;
    int flagi;
    char literka;
};

/* Bardziej skrcona */
struct przedmiot_IO_kr {
    int x, y;
    int ilosc;
    int ID;
};

struct przedmioty {
    wskaznik_przedmiot aktualny, poczatek, koniec;
    int ile;			/* ile przedmiotw */

    short int tablica_literek[ILE_LITEREK];	/* 0 - puste miejsce */

} Przedmioty;

#endif
