/* trasy.c */

#include "trasy.h"

void wyczysc_miejsca()
{
    int i;
    for (i = 0; i < MAXMIEJSC; i++) {
	miejsce[i].x = -1;
	miejsce[i].y = -1;
    }
}

void wyczysc_trasy()
{
    int i, j;
    for (i = 0; i < MAXPOTWOROW; i++)
	for (j = 0; j < MAXTRAS; j++) {
	    trasa.m[i][j] = 0;
	    trasa.a[i] = -1;
	    strcpy(trasa.c[i][j], "");
	}
}

void laduj_miejsca(struct _plik *in)
{
    int i;
    wyczysc_miejsca();
    sread(in, &ile_miejsc, sizeof(ile_miejsc));
    for (i = 0; i < ile_miejsc; i++) {
	sread(in, &miejsce[i], sizeof(struct _miejsce));
    }
}

void zapisz_miejsca(char *out, long int *ile)
{
    int i;
    *ile = 0;
    memcpy(&out[*ile], &ile_miejsc, sizeof(ile_miejsc));
    (*ile) += sizeof(ile_miejsc);
    for (i = 0; i < ile_miejsc; i++) {
	memcpy(&out[*ile], &miejsce[i], sizeof(struct _miejsce));
	(*ile) += sizeof(struct _miejsce);
    }
}

void laduj_trasy(struct _plik *in)
{
    wyczysc_trasy();
    sread(in, &trasa, sizeof(struct _trasa));
}

int szukaj_miejsca(char literka)
{
    int i;
    for (i = 0; i < MAXMIEJSC; i++) {
	if (miejsce[i].literka == literka) {
	    return i;
	}
    }
    return -1;
}
