/* convsw.c (konwerter pliku opisu wiata) */
#include <stdio.h>
#include "fake.h"
#include "swiat.h"

FILE *out, *obraz;

int main()
{
    char obrazek[SWX][SWY][SWZ];
    char tmp2[1000];
    int x, y, z, zdelta, poziom;
    struct _swiat Swiat;
    init_parser("swiat");
    out = fopen("swiatb", "wb");
    obraz = fopen("swiat.lst", "wb");
    /* Wypenienie caego wiata murkiem, coby nie byo segfaultw przy wchodzeniu na nieznane terytoria :) */
    for (x = 0; x < SWX; x++)
	for (y = 0; y < SWY; y++)
	    for (z = 0; z < SWZ; z++) {
		strcpy(Swiat.pole[x][y][z].nazwa, "PROZN");
		Swiat.pole[x][y][z].wygenerowane = 0;
		Swiat.pole[x][y][z].typ = P_SKALA;
		Swiat.pole[x][y][z].maxx = Swiat.pole[x][y][z].maxy = 100;
		obrazek[x][y][z] = '#';
	    }
    /* Czytamy zdelt */
    ustaw_kawalek("<--", "-->");
    zdelta = parser_liczba("Delta:", 1, 0, SP_LICZBA);

    while (!ustaw_kawalek("{", "}")) {
	x = parser_liczba("Wsp:", 1, 0, SP_LICZBA);
	y = parser_liczba("Wsp:", 2, 0, SP_LICZBA);
	z = parser_liczba("Wsp:", 3, 0, SP_LICZBA);
	Swiat.pole[x][y][z + zdelta].flagi =
	    parser_liczba("Fl:", 1, 0, SP_FL_POZ);
	Swiat.pole[x][y][z + zdelta].gen_potw_tur =
	    parser_liczba("Potw:", 1, 400, SP_LICZBA);
	Swiat.pole[x][y][z + zdelta].gen_potw_l = 1;
	poziom = parser_liczba("Poziom:", 1, 0, SP_LICZBA);
	strcpy(Swiat.pole[x][y][z + zdelta].nazwa,
	       parser_string(tmp2, "Nazwa:", 1, "PROZN"));
	Swiat.pole[x][y][z + zdelta].poziom = poziom;
	Swiat.pole[x][y][z + zdelta].dx =
	    parser_liczba("Delta:", 1, 0, SP_LICZBA);
	Swiat.pole[x][y][z + zdelta].dy =
	    parser_liczba("Delta:", 2, 0, SP_LICZBA);
	Swiat.pole[x][y][z + zdelta].droga =
	    parser_liczba("Droga:", 1, 0, SP_LICZBA);
	Swiat.pole[x][y][z + zdelta].wygenerowane =
	    -parser_liczba("Gen:", 1, 0, SP_LICZBA);
	if (!Swiat.pole[x][y][z + zdelta].wygenerowane) {
	    char kolor;
	    Swiat.pole[x][y][z + zdelta].typ =
		parser_liczba("Typ:", 1, 0, SP_TYP_GEN);
	    Swiat.pole[x][y][z + zdelta].maxx =
		parser_liczba("Rozm:", 1, 100, SP_LICZBA);
	    Swiat.pole[x][y][z + zdelta].maxy =
		parser_liczba("Rozm:", 2, 100, SP_LICZBA);
	    switch (Swiat.pole[x][y][z + zdelta].typ) {
	    case P_LAS:
		kolor = 'Y';
		break;
	    case P_POLA:
		kolor = '.';
		break;
	    case P_SKALA:
		kolor = '#';
		break;
	    case P_JASKINIA:
		kolor = '*';
		break;
	    case P_OST_JASKINIA:
		kolor = '+';
		break;
	    default:
		kolor = '?';
		break;
	    }
	    obrazek[x][y][z + zdelta] = kolor;
	} else {
	    obrazek[x][y][z + zdelta] = 'G';
	    Swiat.pole[x][y][z + zdelta].typ = -1;
	}
    }
    fwrite(&Swiat, sizeof(struct _swiat), 1, out);
    fprintf(obraz, "Mapa:\n-------------------------------\n\n");
    for (z = 0; z < SWZ; z++) {
	fprintf(obraz, "\nPoziom %d:\n-----------\n\n", z);
	for (y = 0; y < SWY; y++) {
	    strcpy(tmp2, "");
	    for (x = 0; x < SWX; x++) {
		int len = strlen(tmp2);
		tmp2[len] = obrazek[x][y][z];
		tmp2[len + 1] = '\0';
	    }
	    fprintf(obraz, "%s\n", tmp2);
	}
    }
    fclose(obraz);
    fclose(out);
    end_parser();
    return 0;
}
